Report: data
[csit.git] / bootstrap-vpp-verify-nightly.sh
1 #!/bin/bash
2 # Copyright (c) 2017 Cisco and/or its affiliates.
3 # Licensed under the Apache License, Version 2.0 (the "License");
4 # you may not use this file except in compliance with the License.
5 # You may obtain a ght (c) 2016 Cisco and/or its affiliates.
6 # Licensed under the Apache License, Version 2.0 (the "License");
7 # you may not usecopy of the License at:
8 #
9 #     http://www.apache.org/licenses/LICENSE-2.0
10 #
11 # Unless required by applicable law or agreed to in writing, software
12 # distributed under the License is distributed on an "AS IS" BASIS,
13 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
14 # See the License for the specific language governing permissions and
15 # limitations under the License.
16
17 set -x
18
19 cat /etc/hostname
20 cat /etc/hosts
21
22 ARCHIVE_ARTIFACTS=(log.html output.xml report.html)
23
24 SCRIPT_DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"
25 export PYTHONPATH=${SCRIPT_DIR}
26
27 # Create tmp dir
28 mkdir ${SCRIPT_DIR}/tmp
29
30 # Use tmp dir for tarballs
31 export TMPDIR="${SCRIPT_DIR}/tmp"
32
33 # Use tmp dir to store log files
34 LOG_PATH="$TMPDIR"
35
36 if [ -f "/etc/redhat-release" ]; then
37     DISTRO="CENTOS"
38     sudo yum install -y python-devel python-virtualenv
39     PACKAGE=rpm
40 else
41     DISTRO="UBUNTU"
42     export DEBIAN_FRONTEND=noninteractive
43     sudo apt-get -y update
44     sudo apt-get -y install libpython2.7-dev python-virtualenv
45     PACKAGE=deb
46 fi
47
48 # 1st step: Download and prepare VPP packages
49
50 # Temporarily download VPP packages from nexus.fd.io
51 if [ "${#}" -ne "0" ]; then
52     arr=(${@})
53     echo ${arr[0]}
54 else
55     # Download the latest VPP build install packages
56     rm -f *.${PACKAGE}
57     echo Downloading VPP packages...
58     bash ${SCRIPT_DIR}/resources/tools/download_install_vpp_pkgs.sh --skip-install
59 fi
60
61 # Take vpp package and get the vpp version
62 VPP_PKGS=(*.$PACKAGE)
63 case "$DISTRO" in
64         CENTOS )
65             VPP_VER="$( expr match $(ls *.rpm | head -n 1) 'vpp-\(.*\).rpm' )"
66             ;;
67         UBUNTU )
68             VPP_VER="$( expr match $(ls *.deb | head -n 1) 'vpp-\(.*\)-deb.deb' )"
69 esac
70
71 echo ${VPP_PKGS[@]}
72
73 set +x
74 echo "****************************************************************************************************************************************"
75 echo "1st step: Download VPP packages                                                                                                 FINISHED"
76 echo "VPP version to be tested: ${VPP_VER}"
77 echo "****************************************************************************************************************************************"
78 set -x
79
80
81 # 2nd step: Start virtual env and install requirements
82
83 echo Starting virtual env...
84 virtualenv --system-site-packages env
85 . env/bin/activate
86
87 echo Installing requirements...
88 pip install -r ${SCRIPT_DIR}/requirements.txt
89
90 set +x
91 echo "****************************************************************************************************************************************"
92 echo "2nd step: Start virtual env and install requirements                                                                            FINISHED"
93 echo "****************************************************************************************************************************************"
94 set -x
95
96
97 # 3rd step: Prepare VIRL system
98 echo Preparing VIRL system...
99
100 VIRL_SERVERS=("10.30.51.28" "10.30.51.29" "10.30.51.30")
101 IPS_PER_VIRL=( "10.30.51.28:252"
102                "10.30.51.29:74"
103                "10.30.51.30:74" )
104 SIMS_PER_VIRL=( "10.30.51.28:13"
105                "10.30.51.29:13"
106                "10.30.51.30:13" )
107 IPS_PER_SIMULATION=5
108
109 function get_max_ip_nr() {
110     virl_server=$1
111     IP_VALUE="0"
112     for item in "${IPS_PER_VIRL[@]}" ; do
113         if [ "${item%%:*}" == "${virl_server}" ]
114         then
115             IP_VALUE=${item#*:}
116             break
117         fi
118     done
119     echo "$IP_VALUE"
120 }
121
122 function get_max_sim_nr() {
123     virl_server=$1
124     SIM_VALUE="0"
125     for item in "${SIMS_PER_VIRL[@]}" ; do
126         if [ "${item%%:*}" == "${virl_server}" ]
127         then
128             SIM_VALUE=${item#*:}
129             break
130         fi
131     done
132     echo "$SIM_VALUE"
133 }
134
135 VIRL_USERNAME=jenkins-in
136 VIRL_PKEY=priv_key
137 VIRL_SERVER_STATUS_FILE="status"
138 VIRL_SERVER_EXPECTED_STATUS="PRODUCTION"
139
140 SKIP_PATCH="skip_patchORskip_vpp_patch"
141
142 case "$DISTRO" in
143         CENTOS )
144             VIRL_TOPOLOGY=$(cat ${SCRIPT_DIR}/VIRL_TOPOLOGY_CENTOS)
145             VIRL_RELEASE=$(cat ${SCRIPT_DIR}/VIRL_RELEASE_CENTOS)
146             NON_CRITICAL_TESTS="expected_failingORvm"
147             ;;
148         UBUNTU )
149             VIRL_TOPOLOGY=$(cat ${SCRIPT_DIR}/VIRL_TOPOLOGY_UBUNTU)
150             VIRL_RELEASE=$(cat ${SCRIPT_DIR}/VIRL_RELEASE_UBUNTU)
151             NON_CRITICAL_TESTS="EXPECTED_FAILING"
152             ;;
153 esac
154
155 SSH_OPTIONS="-i ${VIRL_PKEY} -o StrictHostKeyChecking=no -o UserKnownHostsFile=/dev/null -o BatchMode=yes -o LogLevel=error"
156
157 function ssh_do() {
158     echo
159     echo "### "  ssh $@
160     ssh ${SSH_OPTIONS} $@
161 }
162
163 rm -f ${VIRL_PKEY}
164 cat > ${VIRL_PKEY} <<EOF
165 -----BEGIN RSA PRIVATE KEY-----
166 MIIEpQIBAAKCAQEA+IHXq87GcqMR1C47rzx6Cbip5Ghq8pKrbqKrP5Nf41HcYrT6
167 GOXl9nFWKsMOzIlIn+8y7Il27eZh7csQGApbg8QLiHMtcYEmWNzKZpkqg4nuAPxX
168 VXwlKgnKX902SrET9Gp9TDayiHtCRWVfrlPPPSA0UEXW6BjLN/uHJ+W/Xzrrab+9
169 asBVa05vT2W6n0KJ66zfCaeDM912mQ6SttscAwFoWDmdHlegiVqrlIG2ABxOvxxz
170 L3dM3iSmlmQlzv9bThjo+nI4KFYh6m5wrZmAo5r/4q9CIJc21HVnTqkGOWJIZz6J
171 73lePJVSq5gYqaoGw3swFEA/MDkOx7baWKSoLQIDAQABAoIBAQCNBeolNp+JWJ76
172 gQ4fwLsknyXSV6sxYyhkDW4PEwwcTU06uqce0AAzXVffxne0fMe48x47+zqBgPbb
173 4huM+Pu8B9nfojUMr5TaYtl9Zbgpk3F8H7dT7LKOa6XrxvZTZrADSRc30+Z26zPN
174 e9zTaf42Gvt0/l0Zs1BHwbaOXqO+XuwJ3/F9Sf3PQYWXD3EOWjpHDP/X/1vAs6lV
175 SLkm6J/9KKE1m6I6LTYjIXuYt4SXybW6N2TSy54hhQtYcDUnIU2hR/PHVWKrGA0J
176 kELgrtTNTdbML27O5gFWU4PLUEYTZ9fN11D6qUZKxLcPOiPPHXkiILMRCCnG5DYI
177 ksBAU/YlAoGBAPxZO9VO18TYc8THV1nLKcvT2+1oSs1UcA2wNQMU55t910ZYinRa
178 MRwUhMOf8Mv5wOeiZaRICQB1PnVWtDVmGECgPpK6jUxqAwn8rgJcnoafLGL5YKMY
179 RVafTe6N5LXgCaOcJrk21wxs6v7ninEbUxxc575urOvZMBkymDw91dwbAoGBAPwa
180 YRhKhrzFKZzdK0RadVjnxKvolUllpoqqg3XuvmeAJHAOAnaOgVWq68NAcp5FZJv0
181 2D2Up7TX8pjf9MofP1SJbcraKBpK4NzfNkA0dSdEi+FhVofAJ9umB2o5LW1n7sab
182 UIrjsdzSJK/9Zb9yTTHPyibYzNEgaJV1HsbxfEFXAoGAYO2RmvRm0phll18OQVJV
183 IpKk9kLKAKZ/R/K32hAsikBC8SVPQTPniyaifFWx81diblalff2hX4ipTf7Yx24I
184 wMIMZuW7Im/R7QMef4+94G3Bad7p7JuE/qnAEHJ2OBnu+eYfxaK35XDsrq6XMazS
185 NqHE7hOq3giVfgg+C12hCKMCgYEAtu9dbYcG5owbehxzfRI2/OCRsjz/t1bv1seM
186 xVMND4XI6xb/apBWAZgZpIFrqrWoIBM3ptfsKipZe91ngBPUnL9s0Dolx452RVAj
187 yctHB8uRxWYgqDkjsxtzXf1HnZBBkBS8CUzYj+hdfuddoeKLaY3invXLCiV+PpXS
188 U4KAK9kCgYEAtSv0m5+Fg74BbAiFB6kCh11FYkW94YI6B/E2D/uVTD5dJhyEUFgZ
189 cWsudXjMki8734WSpMBqBp/J8wG3C9ZS6IpQD+U7UXA+roB7Qr+j4TqtWfM+87Rh
190 maOpG56uAyR0w5Z9BhwzA3VakibVk9KwDgZ29WtKFzuATLFnOtCS46E=
191 -----END RSA PRIVATE KEY-----
192 EOF
193 chmod 600 ${VIRL_PKEY}
194
195 #
196 # The server must be reachable and have a "status" file with
197 # the content "PRODUCTION" to be selected.
198 #
199 # If the server is not reachable or does not have the correct
200 # status remove it from the array and start again.
201 #
202 # Abort if there are no more servers left in the array.
203 #
204 VIRL_PROD_SERVERS=()
205 for index in "${!VIRL_SERVERS[@]}"; do
206     virl_server_status=$(ssh ${SSH_OPTIONS} ${VIRL_USERNAME}@${VIRL_SERVERS[$index]} cat $VIRL_SERVER_STATUS_FILE 2>&1)
207     echo VIRL HOST ${VIRL_SERVERS[$index]} status is \"$virl_server_status\"
208     if [ "$virl_server_status" == "$VIRL_SERVER_EXPECTED_STATUS" ]
209     then
210         # Candidate is in good status. Add to array.
211         VIRL_PROD_SERVERS+=(${VIRL_SERVERS[$index]})
212     fi
213 done
214
215 VIRL_SERVERS=("${VIRL_PROD_SERVERS[@]}")
216 echo "VIRL servers in production: ${VIRL_SERVERS[@]}"
217 num_hosts=${#VIRL_SERVERS[@]}
218 if [ $num_hosts == 0 ]
219 then
220     echo "No more VIRL candidate hosts available, failing."
221     exit 127
222 fi
223
224 # Get the LOAD of each server based on number of active simulations (test cases)
225 VIRL_SERVER_LOAD=()
226 for index in "${!VIRL_SERVERS[@]}"; do
227     VIRL_SERVER_LOAD[${index}]=$(ssh ${SSH_OPTIONS} ${VIRL_USERNAME}@${VIRL_SERVERS[$index]} "list-testcases | grep session | wc -l")
228 done
229
230 # Pick the least loaded server
231 VIRL_SERVER=""
232 least_load_server_idx=$(echo "${VIRL_SERVER_LOAD[*]}" | tr -s ' ' '\n' | awk '{print($0" "NR)}' | sort -g -k1,1 | head -1 | cut -f2 -d' ')
233 least_load_server=${VIRL_SERVERS[$least_load_server_idx-1]}
234 VIRL_SERVER=($least_load_server)
235
236 echo "Selected VIRL servers: ${VIRL_SERVER[@]}"
237
238 VIRL_DIR_LOC="/tmp"
239 VPP_PKGS_VIRL=(${VPP_PKGS[@]})
240
241 # Prepend directory location at remote host to package file list
242 for index in "${!VPP_PKGS_VIRL[@]}"; do
243     VPP_PKGS_VIRL[${index}]=${VIRL_DIR_LOC}/${VPP_PKGS_VIRL[${index}]}
244 done
245
246 echo "Updated file names: " ${VPP_PKGS_VIRL[@]}
247
248 cat ${VIRL_PKEY}
249 # Copy the files to VIRL host
250 scp ${SSH_OPTIONS} *.${PACKAGE} \
251     ${VIRL_USERNAME}@${VIRL_SERVER}:${VIRL_DIR_LOC}/
252
253 result=$?
254 if [ "${result}" -ne "0" ]; then
255     echo "Failed to copy vpp package files to virl host"
256     echo ${result}
257     exit ${result}
258 fi
259
260 function stop_virl_simulation {
261     ssh ${SSH_OPTIONS} ${VIRL_USERNAME}@${VIRL_SERVER}\
262         "stop-testcase ${VIRL_SID}"
263 }
264
265 # Upon script exit, cleanup the VIRL simulation execution
266 trap stop_virl_simulation EXIT
267
268 # Start a simulation on VIRL server
269 echo "Starting simulation on VIRL server"
270
271 # Get given VIRL server limits for max. number of VMs and IPs
272 max_ips=$(get_max_ip_nr ${VIRL_SERVER})
273 max_ips_from_sims=$(($(get_max_sim_nr ${VIRL_SERVER[${index}]})*IPS_PER_SIMULATION))
274 # Set quota to lower value
275 IP_QUOTA=$([ $max_ips -le $max_ips_from_sims ] && echo "$max_ips" || echo "$max_ips_from_sims")
276
277 # Start the simulation
278 VIRL_SID=$(ssh ${SSH_OPTIONS} \
279     ${VIRL_USERNAME}@${VIRL_SERVER} \
280     "start-testcase -vv --quota ${IP_QUOTA} --copy ${VIRL_TOPOLOGY} \
281     --release ${VIRL_RELEASE} ${VPP_PKGS_VIRL[@]}")
282 retval=$?
283 if [ ${retval} -ne "0" ]; then
284     echo "VIRL simulation start failed on ${VIRL_SERVER}"
285     exit ${retval}
286 fi
287
288 if [[ ! "${VIRL_SID}" =~ session-[a-zA-Z0-9_]{6} ]]; then
289     echo "No VIRL session ID reported."
290     exit 127
291 fi
292
293 echo ${VIRL_SID}
294
295 ssh_do ${VIRL_USERNAME}@${VIRL_SERVER} cat /scratch/${VIRL_SID}/topology.yaml
296
297 # Download the topology file from VIRL session
298 scp ${SSH_OPTIONS} \
299     ${VIRL_USERNAME}@${VIRL_SERVER}:/scratch/${VIRL_SID}/topology.yaml \
300     topologies/enabled/topology_VIRL.yaml
301
302 retval=$?
303 if [ ${retval} -ne "0" ]; then
304     echo "Failed to copy topology file from VIRL simulation"
305     exit ${retval}
306 fi
307
308 set +x
309 echo "****************************************************************************************************************************************"
310 echo "3rd step: Start the simulation on the VIRL server                                                                               FINISHED"
311 echo "****************************************************************************************************************************************"
312 set -x
313
314
315 # 4th step: Run functional test suites
316
317 pykwalify -s ${SCRIPT_DIR}/resources/topology_schemas/3_node_topology.sch.yaml \
318           -s ${SCRIPT_DIR}/resources/topology_schemas/topology.sch.yaml \
319           -d ${SCRIPT_DIR}/topologies/enabled/topology_VIRL.yaml \
320           -vvv
321 if [ "$?" -ne "0" ]; then
322     echo "Topology schema validation failed."
323     echo "However, the tests will start."
324 fi
325
326 echo Running functional tests on the VIRL system...
327
328 echo "PYTHONPATH=`pwd` pybot -L TRACE -W 136\
329     -v TOPOLOGY_PATH:${SCRIPT_DIR}/topologies/enabled/topology_VIRL.yaml \
330     --suite "tests.func" \
331     --include vm_envAND3_node_single_link_topo \
332     --include vm_envAND3_node_double_link_topo \
333     --exclude PERFTEST \
334     --exclude ${SKIP_PATCH} \
335     --noncritical ${NON_CRITICAL_TESTS} \
336     --outputdir ${LOG_PATH} \
337     tests/"
338
339 PYTHONPATH=`pwd` pybot -L TRACE -W 136\
340     -v TOPOLOGY_PATH:${SCRIPT_DIR}/topologies/enabled/topology_VIRL.yaml \
341     --suite "tests.func" \
342     --include vm_envAND3_node_single_link_topo \
343     --include vm_envAND3_node_double_link_topo \
344     --exclude PERFTEST \
345     --exclude ${SKIP_PATCH} \
346     --noncritical ${NON_CRITICAL_TESTS} \
347     --outputdir ${LOG_PATH} \
348     tests/
349 RC=$(echo $?)
350
351 set +x
352 echo "****************************************************************************************************************************************"
353 echo "4th step: Run functional tests                                                                                                  FINISHED"
354 echo "****************************************************************************************************************************************"
355 set -x
356
357 # Log the final result
358 if [ ${RC} -eq 0 ]; then
359     RETURN_STATUS=0
360     set +x
361     echo
362     echo "========================================================================================================================================"
363     echo "Final result of all tests:                                                                                                      | PASS |"
364     echo "All critical tests have passed."
365     echo "========================================================================================================================================"
366     echo
367     set -x
368 elif [ ${MORE_FAILS} -eq 0 ]; then
369     RETURN_STATUS=1
370     if [ ${RC} -eq 1 ]; then
371         HLP_STR="test has"
372     else
373         HLP_STR="tests have"
374     fi
375     set +x
376     echo
377     echo "========================================================================================================================================"
378     echo "Final result of all tests:                                                                                                      | FAIL |"
379     echo "${RC} critical ${HLP_STR} failed."
380     echo "========================================================================================================================================"
381     echo
382     set -x
383 else
384     RETURN_STATUS=1
385     set +x
386     echo
387     echo "========================================================================================================================================"
388     echo "Final result of all tests:                                                                                                      | FAIL |"
389     echo "More then 250 critical tests have failed in one test loop."
390     echo "========================================================================================================================================"
391     echo
392     set -x
393 fi
394
395
396 # 5th step: Archive artifacts
397 mkdir archive
398 for i in ${ARCHIVE_ARTIFACTS[@]}; do
399     cp $( readlink -f ${LOG_PATH}/${i} | tr '\n' ' ' ) archive/
400 done
401
402 echo Log files copied to archive directory.
403
404 exit ${RETURN_STATUS}

©2016 FD.io a Linux Foundation Collaborative Project. All Rights Reserved.
Linux Foundation is a registered trademark of The Linux Foundation. Linux is a registered trademark of Linus Torvalds.
Please see our privacy policy and terms of use.